// MotorSampleDlg.cpp : t@C
//

#include "stdafx.h"
#include "MotorSample.h"
#include "MotorSampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CMotorSampleDlg _CAO




CMotorSampleDlg::CMotorSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMotorSampleDlg::IDD, pParent)
	, m_DevNum(0)
	, m_SlctSpin(FALSE)
	, m_SlctResolve(FALSE)
	, m_SlctCurrent(FALSE)
	, m_CurNum(0)
	, m_Num(1)
	, m_Freq(10000)
	, m_InfoSpin(TRUE)
	, m_PhaseNum(0)
	, m_InfoAlarm(TRUE)
	, m_Address(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_hDev = NULL;
	m_lnPhase = 0;
	m_wnTemp = 0;
	m_flgStart = FALSE;
	m_flgUpdate = TRUE;

	m_DevNum = 0;
	m_Address = _T("");
	m_SlctSpin = FALSE;
	m_SlctResolve = FALSE;
	m_SlctCurrent = FALSE;
	m_CurNum = 0;
	m_Num = 1;
	m_Freq = 10000;
	m_InfoSpin = TRUE;
	m_PhaseNum = 0;
	m_InfoAlarm = TRUE;
}

void CMotorSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_NUMBER, m_DevNum);
	DDX_Radio(pDX, IDC_CWSPIN, m_SlctSpin);
	DDX_Radio(pDX, IDC_RESOLVE1, m_SlctResolve);
	DDX_Radio(pDX, IDC_CURRENT_ON, m_SlctCurrent);
	DDX_Text(pDX, IDC_EDIT_CUR, m_CurNum);
	DDX_Text(pDX, IDC_EDIT_NUM, m_Num);
	DDV_MinMaxLong(pDX, m_Num, 1, 0x7FFFFFFF);
	DDX_Control(pDX, IDC_FREQ, m_SldFreq);
	DDX_Text(pDX, IDC_EDIT_FREQ, m_Freq);
	DDV_MinMaxLong(pDX, m_Freq, 50, 100000);
	DDX_Radio(pDX, IDC_MOTOR_ON, m_InfoSpin);
	DDX_Text(pDX, IDC_EDIT_PHASE_NUM, m_PhaseNum);
	DDX_Radio(pDX, IDC_ALARM_ON, m_InfoAlarm);
	DDX_Text(pDX, IDC_ADDRESS, m_Address);
}

BEGIN_MESSAGE_MAP(CMotorSampleDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_Connect, &CMotorSampleDlg::OnBnClickedConnect)
	ON_BN_CLICKED(IDC_AddrConnect, &CMotorSampleDlg::OnBnClickedAddrconnect)
	ON_BN_CLICKED(IDC_Disconnect, &CMotorSampleDlg::OnBnClickedDisconnect)
	ON_BN_CLICKED(IDC_Start, &CMotorSampleDlg::OnBnClickedStart)
	ON_BN_CLICKED(IDC_Stop, &CMotorSampleDlg::OnBnClickedStop)
	ON_BN_CLICKED(IDC_ENABLE_NUM, &CMotorSampleDlg::OnBnClickedEnableNum)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_Clear, &CMotorSampleDlg::OnBnClickedClear)
	ON_BN_CLICKED(IDC_Reset, &CMotorSampleDlg::OnBnClickedReset)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_RESOLVE1, &CMotorSampleDlg::OnBnClickedResolve1)
	ON_BN_CLICKED(IDC_RESOLVE10, &CMotorSampleDlg::OnBnClickedResolve10)
	ON_BN_CLICKED(IDC_CURRENT_ON, &CMotorSampleDlg::OnBnClickedCurrentOn)
	ON_BN_CLICKED(IDC_CURRENT_OFF, &CMotorSampleDlg::OnBnClickedCurrentOff)
	ON_EN_SETFOCUS(IDC_EDIT_NUM, &CMotorSampleDlg::OnEnSetfocusEditNum)
	ON_EN_KILLFOCUS(IDC_EDIT_NUM, &CMotorSampleDlg::OnEnKillfocusEditNum)
	ON_EN_SETFOCUS(IDC_EDIT_FREQ, &CMotorSampleDlg::OnEnSetfocusEditFreq)
	ON_EN_KILLFOCUS(IDC_EDIT_FREQ, &CMotorSampleDlg::OnEnKillfocusEditFreq)
END_MESSAGE_MAP()


// CMotorSampleDlg bZ[W nh

BOOL CMotorSampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	//XC_̏
	m_SldFreq.SetRange(50, 100000);
	m_SldFreq.SetPos(10000);
	m_SldFreq.SetPageSize(10);

	//Rg[̐ݒ
	UpdateControlEnable();

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CMotorSampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CMotorSampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CMotorSampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

//uԍw肵Đڑ{^
void CMotorSampleDlg::OnBnClickedConnect()
{
	TW_STATUS ret;
	CString str;
	long Number = 0;

	//foCX̐ڑԂmF
	if(m_hDev) return;

	//uԍ擾
	Number = m_DevNum;
	if(UpdateData(TRUE) == FALSE){
		m_DevNum = Number;
		UpdateData(FALSE);
		return;
	}
	Number = m_DevNum;

	//foCXɐڑ
	if(TWXA_Open(&m_hDev, Number, TWXA_IF_ANY | TWXA_TYPE_ANY | TWXA_LIST_UPDATE)){
		AfxMessageBox(_T("foCX̐ڑɎs܂"));
		return;
	}
	//foCX̏
	if(TWXA_Initialize(m_hDev)){
		OnBnClickedDisconnect();
		AfxMessageBox(_T("foCX̏Ɏs܂"));
		return;
	}

	try{
		//`l22pXJEg[hɐݒ
		if(ret = TWXA_TimerSetMode(m_hDev, 2, TWXA_TIMER_2PHASE)) throw ret;
		if(ret = TWXA_TimerSetCnt(m_hDev, 2, 0)) throw ret;
		m_PhaseNum = 0;
		m_lnPhase = 0;
		m_wnTemp = 0;
		UpdateData(FALSE);
		
		//̓pX̃JEgJn
		if(ret = TWXA_TimerStart(m_hDev, TWXA_TIMER_BIT2)) throw ret;
	}
	catch(TW_STATUS ret){
		OnBnClickedDisconnect();
		str.Format(_T("G[܂:TW_STATUS=%08X"), ret);
		AfxMessageBox(str);
		return;
	}

	//Rg[̐ݒ
	UpdateControlEnable();
	//^C}X^[g
	SetTimer(0, 50, NULL);
}

//AhXw肵Đڑ{^
void CMotorSampleDlg::OnBnClickedAddrconnect()
{
	TW_STATUS ret;
	CString str;

	//foCX̐ڑԂmF
	if(m_hDev) return;

	//AhX擾
	GetDlgItemText(IDC_ADDRESS, str);
	if(str.IsEmpty()){
		AfxMessageBox(_T("AhXw肵Ă"));
		return;
	}

	//AhXw肵Đڑ
	if(TWXA_OpenByAddress(&m_hDev, str, TWXA_IF_LAN | TWXA_TYPE_I2219 | TWXA_TYPE_N2219)){
		AfxMessageBox(_T("foCX̐ڑɎs܂"));
		return;
	}
	//foCX̏
	if(TWXA_Initialize(m_hDev)){
		OnBnClickedDisconnect();
		AfxMessageBox(_T("foCX̏Ɏs܂"));
		return;
	}

	try{
		//`l22pXJEg[hɐݒ
		if(ret = TWXA_TimerSetMode(m_hDev, 2, TWXA_TIMER_2PHASE)) throw ret;
		if(ret = TWXA_TimerSetCnt(m_hDev, 2, 0)) throw ret;
		m_PhaseNum = 0;
		m_lnPhase = 0;
		m_wnTemp = 0;
		UpdateData(FALSE);

		//̓pX̃JEgJn
		if(ret = TWXA_TimerStart(m_hDev, TWXA_TIMER_BIT2)) throw ret;
	}
	catch(TW_STATUS ret){
		OnBnClickedDisconnect();
		str.Format(_T("G[܂:TW_STATUS=%08X"), ret);
		AfxMessageBox(str);
		return;
	}

	//Rg[̐ݒ
	UpdateControlEnable();
	//^C}X^[g
	SetTimer(0, 50, NULL);
}

//foCXؒf{^
void CMotorSampleDlg::OnBnClickedDisconnect()
{
	double freq;
	double duty = 0.0;

	//foCX̐ڑԂmF
	if(m_hDev == NULL) return;

	//S`l~
	freq = m_SldFreq.GetPos();
	TWXA_TimerSetPwm(m_hDev, 0, &freq, &duty, NULL);
	TWXA_TimerStop(m_hDev, TWXA_TIMER_BITS_ALL);

	//foCXؒf
	TWXA_Close(m_hDev);
	//nh̏
	m_hDev = NULL;
	//tȌ
	m_flgStart = FALSE;
	m_flgUpdate = TRUE;

	//^C}Xgbv
	KillTimer(0);
	//Rg[̐ݒ
	UpdateControlEnable();
}

//]Jn{^
void CMotorSampleDlg::OnBnClickedStart()
{
	TW_STATUS ret;
	CString str;
	CButton *pBtn;
	BYTE Status;

	try{
		//hCo̓͏擾
		if(ret = TWXA_PortRead(m_hDev, TWXA_PIa, &Status)) throw ret;
		//A[̔󋵂mF
		if((Status & 0x01) == 0){
			AfxMessageBox(_T("A[Ă"));
			return;
		}

		//DIR.̐ݒ
		UpdateData(TRUE);
		if(m_SlctSpin == FALSE){
			//CW Spin  : Od7ONɂ
			if(ret = TWXA_PortWrite(m_hDev, TWXA_POd, 0x80, 0x80)) throw ret;
		}else{
			//CCW Spin : Od7OFFɂ
			if(ret = TWXA_PortWrite(m_hDev, TWXA_POd, 0x00, 0x80)) throw ret;
		}

		//`l0PWMo͂ɐݒ
		if(ret = TWXA_TimerSetMode(m_hDev, 0, TWXA_TIMER_PWM)) throw ret;

		//pXw肷ꍇAlZbg
		pBtn = (CButton*)GetDlgItem(IDC_ENABLE_NUM);
		if(pBtn->GetCheck() == 1){
			if(ret = TWXA_TimerSetNumOfPulse(m_hDev, 0, m_Num)) throw ret;
		}
		//o͉񐔂̃GfBbg\0ɂ
		m_CurNum = 0;

		//PWMp[^ݒ
		UpdatePwmParam();

		//`l0PWMo͊Jn
		if(ret = TWXA_TimerStart(m_hDev, TWXA_TIMER_BIT0)) throw ret;
	}
	catch(TW_STATUS ret){
		OnBnClickedDisconnect();
		str.Format(_T("G[܂:TW_STATUS=%08X"), ret);
		AfxMessageBox(str);
		return;
	}

	//tOݒ
	m_flgStart = TRUE;
	//Rg[̐ݒ
	UpdateControlEnable(TRUE);
}

//]~{^
void CMotorSampleDlg::OnBnClickedStop()
{
	TW_STATUS ret;
	CString str;

	//tOݒ
	m_flgStart = FALSE;

	try{
		//ONԂŏIȂ悤PWM[qfW^o͂ɕύXďI
		if(ret = TWXA_PortWrite(m_hDev, TWXA_POf, 0x00)) throw ret;
		//PWM`l~
		if(ret = TWXA_TimerSetMode(m_hDev, 0, TWXA_TIMER_DISABLE)) throw ret;
		//̂߂PWMo͂̃xItɖ߂
		if(ret = TWXA_TimerSetLevel(m_hDev, 0)) throw ret;
	}
	catch(TW_STATUS ret){
		OnBnClickedDisconnect();
		str.Format(_T("G[܂:TW_STATUS=%08X"), ret);
		AfxMessageBox(ret);
		return;
	}

	//Rg[̐ݒ
	UpdateControlEnable(FALSE);
}

//pXw肷`FbN{bNX
void CMotorSampleDlg::OnBnClickedEnableNum()
{
	UpdateControlEnable(FALSE);
}

//XC_̑쎞
void CMotorSampleDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	UpdatePwmParam();

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

//JEglNA{^
void CMotorSampleDlg::OnBnClickedClear()
{
	TW_STATUS ret;
	CString str;

	//foCX̐ڑԂmF
	if(m_hDev == NULL) return;
	if(ret = TWXA_TimerSetCnt(m_hDev, 2, 0)){
		OnBnClickedDisconnect();
		str.Format(_T("G[܂:TW_STATUS=%08X"), ret);
		AfxMessageBox(str);
		return;
	}
	m_PhaseNum = 0;
	m_lnPhase = 0;
	m_wnTemp = 0;
	UpdateData(FALSE);
}

//A[{^
void CMotorSampleDlg::OnBnClickedReset()
{
	TW_STATUS ret;
	CString str;

	//foCX̐ڑԂmF
	if(m_hDev == NULL) return;
	try{
		if(ret = TWXA_PortWrite(m_hDev, TWXA_POd, 0x01, 0x01)) throw ret;
		//ONԂ̊m
		Sleep(200);
		if(ret = TWXA_PortWrite(m_hDev, TWXA_POd, 0x00, 0x01)) throw ret;
	}
	catch(TW_STATUS ret){
		OnBnClickedDisconnect();
		str.Format(_T("G[܂:TW_STATUS=%08X"), ret);
		AfxMessageBox(str);
	}
}

//tH[ۂɌĂяo܂
void CMotorSampleDlg::OnDestroy()
{
	CDialog::OnDestroy();

	if(m_hDev) OnBnClickedDisconnect();
}

//ɌĂяo܂
void CMotorSampleDlg::OnTimer(UINT_PTR nIDEvent)
{
	TW_STATUS ret;
	CString str;
	CButton *pBtn;
	DWORD dw;
	long lStatus;
	WORD wCnt;
	BYTE bStatus;
	CEdit *pEdit;

	//foCX̐ڑԂmF
	if(m_hDev == NULL) return;
	if(m_flgUpdate == TRUE) UpdateData(TRUE);
	try{
		//vJntOmF
		if(m_flgStart == TRUE){
			//pXw肵ĂꍇAc̃pXǂݏo
			pBtn = (CButton*)GetDlgItem(IDC_ENABLE_NUM);
			if(pBtn->GetCheck() == 1){
				//c̃pXǂݏo
				if(ret = TWXA_TimerReadNumOfPulse(m_hDev, 0, &dw)) throw ret;
				m_CurNum = m_Num - dw;  //o͂pXvZ
				pEdit = (CEdit*)GetDlgItem(IDC_EDIT_CUR);
				str.Format(_T("%ld"), m_CurNum);
				pEdit->SetWindowText(str);
			}
			
			//^C}̓Ԃ𒲂ׂ
			if(ret = TWXA_TimerReadStatus(m_hDev, &lStatus)) throw ret;
			if(!(lStatus & 0x01)){  //~Ă邩mF
				OnBnClickedStop();
			}
		}

		//2pX͂̃JEglǂݏo
		if(ret = TWXA_TimerReadCnt(m_hDev, 2, (short*)&wCnt)) throw ret;
		//̓pX̃JEglGfBbgɔf
		if(m_wnTemp != wCnt){
			if(m_wnTemp > wCnt && (m_wnTemp - wCnt) > 0x8000) m_lnPhase += 0x00010000;  //OverFlow
			if(m_wnTemp < wCnt && (wCnt - m_wnTemp) > 0x8000) m_lnPhase -= 0x00010000;  //UnderFlow

			//16rbg32rbgɊg
			m_PhaseNum = ((m_lnPhase & 0xFFFF0000) | ((long)wCnt & 0x0000FFFF));
			pEdit = (CEdit*)GetDlgItem(IDC_EDIT_PHASE_NUM);
			str.Format(_T("%ld"), m_PhaseNum);
			pEdit->SetWindowText(str);

			//JEglRs[
			m_wnTemp = wCnt;
		}

		//hCõXe[^XmF
		if(ret = TWXA_PortRead(m_hDev, TWXA_PIa, &bStatus)) throw ret;
	}
	catch(TW_STATUS ret){
		OnBnClickedDisconnect();
		str.Format(_T("G[܂:TW_STATUS=%08X"), ret);
		AfxMessageBox(str);
		return;
	}
	//A[̔
	if(!(bStatus & 0x01)){
		//A[
		m_InfoAlarm = FALSE;
		if(m_flgStart == TRUE) OnBnClickedStop();
	}else{
		//A[
		m_InfoAlarm = TRUE;
	}
	//[^[̓
	if(!(bStatus & 0x02)){
		//]
		m_InfoSpin = FALSE;
	}else{
		//~
		m_InfoSpin = TRUE;
	}
	if(m_flgUpdate == TRUE) UpdateData(FALSE);

	CDialog::OnTimer(nIDEvent);
}

//\:~1
void CMotorSampleDlg::OnBnClickedResolve1()
{
	TW_STATUS ret;
	CString str;

	//foCX̐ڑԂmF
	if(m_hDev == NULL) return;
	if(ret = TWXA_PortWrite(m_hDev, TWXA_POd, 0x00, 0x02)){
		OnBnClickedDisconnect();
		str.Format(_T("G[܂:TW_STATUS=%08X"), ret);
		AfxMessageBox(str);
	}
}

//\:~10
void CMotorSampleDlg::OnBnClickedResolve10()
{
	TW_STATUS ret;
	CString str;

	//foCX̐ڑԂmF
	if(m_hDev == NULL) return;
	if(ret = TWXA_PortWrite(m_hDev, TWXA_POd, 0x02, 0x02)){
		OnBnClickedDisconnect();
		str.Format(_T("G[܂:TW_STATUS=%08X"), ret);
		AfxMessageBox(str);
	}
}

//[^[ւ̓d:ON
void CMotorSampleDlg::OnBnClickedCurrentOn()
{
	TW_STATUS ret;
	CString str;

	//foCX̐ڑԂmF
	if(m_hDev == NULL) return;
	if(ret = TWXA_PortWrite(m_hDev, TWXA_POd, 0x00, 0x04)){
		OnBnClickedDisconnect();
		str.Format(_T("G[܂:TW_STATUS=%08X"), ret);
		AfxMessageBox(str);
		return;
	}

	//Rg[̐ݒ
	GetDlgItem(IDC_Start)->EnableWindow(TRUE);
}

//[^[ւ̓d:OFF
void CMotorSampleDlg::OnBnClickedCurrentOff()
{
	TW_STATUS ret;
	CString str;

	//foCX̐ڑԂmF
	if(m_hDev == NULL) return;
	if(ret = TWXA_PortWrite(m_hDev, TWXA_POd, 0x04, 0x04)){
		OnBnClickedDisconnect();
		str.Format(_T("G[܂:TW_STATUS=%08X"), ret);
		AfxMessageBox(str);
		return;
	}

	//Rg[̐ݒ
	GetDlgItem(IDC_Start)->EnableWindow(FALSE);
}

//pXwGfBbg{bNX̃tH[JX:ON
void CMotorSampleDlg::OnEnSetfocusEditNum()
{
	m_flgUpdate = FALSE;
}

//pXwGfBbg{bNX̃tH[JX:OFF
void CMotorSampleDlg::OnEnKillfocusEditNum()
{
	long Num;

	Num = m_Num;
	if(UpdateData(TRUE) == FALSE){
		m_Num = Num;
	}
	m_flgUpdate = TRUE;
	UpdateData(FALSE);
}

//gwGfBbg{bNX̃tH[JX:ON
void CMotorSampleDlg::OnEnSetfocusEditFreq()
{
	m_flgUpdate = FALSE;
}

//gwGfBbg{bNX̃tH[JX:OFF
void CMotorSampleDlg::OnEnKillfocusEditFreq()
{
	TW_STATUS ret;
	CString str;
	double Freq;
	double Duty;
	double Phase;

	//GfBbg̊mF
	Freq = (double)m_Freq;
	if(UpdateData(TRUE) == FALSE){
		m_Freq = (long)Freq;
	}

	m_flgUpdate = TRUE;
	Freq = (double)m_Freq;
	Duty = 0.5;
	Phase = 0.0;

	if(ret = TWXA_TimerSetPwm(m_hDev, 0, &Freq, &Duty, &Phase)){
		OnBnClickedDisconnect();
		str.Format(_T("G[܂:TW_STATUS=%08X"), ret);
		AfxMessageBox(str);
		return;
	}

	//g\ɔf
	m_Freq = (long)Freq;
	//XC_[ɔf
	m_SldFreq.SetPos((long)(Freq + 0.5));
	UpdateData(FALSE);
}

//eRg[̐ݒ
void CMotorSampleDlg::UpdateControlEnable(BOOL startFlg)
{
	CButton *pBtn;
	CEdit *pEdit;

	if(m_flgUpdate == TRUE) UpdateData(TRUE);
	//foCX̐ڑԂmF
	if(m_hDev){
		//ڑ
		GetDlgItem(IDC_Connect)->EnableWindow(FALSE);
		GetDlgItem(IDC_AddrConnect)->EnableWindow(FALSE);
		GetDlgItem(IDC_Disconnect)->EnableWindow(TRUE);

		GetDlgItem(IDC_NUMBER)->EnableWindow(FALSE);
		GetDlgItem(IDC_ADDRESS)->EnableWindow(FALSE);

		//tO̊mF
		if(startFlg == TRUE){
			//vJn
			GetDlgItem(IDC_CWSPIN)->EnableWindow(FALSE);
			GetDlgItem(IDC_CCWSPIN)->EnableWindow(FALSE);
			GetDlgItem(IDC_RESOLVE1)->EnableWindow(FALSE);
			GetDlgItem(IDC_RESOLVE10)->EnableWindow(FALSE);
			GetDlgItem(IDC_CURRENT_ON)->EnableWindow(FALSE);
			GetDlgItem(IDC_CURRENT_OFF)->EnableWindow(FALSE);

			GetDlgItem(IDC_Start)->EnableWindow(FALSE);
			GetDlgItem(IDC_Stop)->EnableWindow(TRUE);
			GetDlgItem(IDC_Reset)->EnableWindow(FALSE);

			GetDlgItem(IDC_ENABLE_NUM)->EnableWindow(FALSE);
			pEdit = (CEdit*)GetDlgItem(IDC_EDIT_NUM);
			pEdit->SetReadOnly(TRUE);
		}else{
			//v~
			GetDlgItem(IDC_CWSPIN)->EnableWindow(TRUE);
			GetDlgItem(IDC_CCWSPIN)->EnableWindow(TRUE);
			GetDlgItem(IDC_RESOLVE1)->EnableWindow(TRUE);
			GetDlgItem(IDC_RESOLVE10)->EnableWindow(TRUE);
			GetDlgItem(IDC_CURRENT_ON)->EnableWindow(TRUE);
			GetDlgItem(IDC_CURRENT_OFF)->EnableWindow(TRUE);

			//dWI{^̊mF
			if(m_SlctCurrent == FALSE){
				//d:ON
				GetDlgItem(IDC_Start)->EnableWindow(TRUE);
			}else{
				//d:OFF
				GetDlgItem(IDC_Start)->EnableWindow(FALSE);
			}
			GetDlgItem(IDC_Stop)->EnableWindow(FALSE);
			GetDlgItem(IDC_Reset)->EnableWindow(TRUE);

			GetDlgItem(IDC_ENABLE_NUM)->EnableWindow(TRUE);
			pEdit = (CEdit*)GetDlgItem(IDC_EDIT_NUM);
			pEdit->SetReadOnly(FALSE);
		}
		//pXw`FbN{bNX̊mF
		pBtn = (CButton*)GetDlgItem(IDC_ENABLE_NUM);
		if(pBtn->GetCheck() == 1){
			//pXw`FbN{bNX:ON
			GetDlgItem(IDC_EDIT_CUR)->EnableWindow(TRUE);
			GetDlgItem(IDC_EDIT_NUM)->EnableWindow(TRUE);
		}else{
			//pXw`FbN{bNX:OFF
			GetDlgItem(IDC_EDIT_CUR)->EnableWindow(FALSE);
			GetDlgItem(IDC_EDIT_NUM)->EnableWindow(FALSE);
		}
		GetDlgItem(IDC_FREQ)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_FREQ)->EnableWindow(TRUE);

		GetDlgItem(IDC_MOTOR_ON)->EnableWindow(TRUE);
		GetDlgItem(IDC_MOTOR_OFF)->EnableWindow(TRUE);
		GetDlgItem(IDC_ALARM_ON)->EnableWindow(TRUE);
		GetDlgItem(IDC_ALARM_OFF)->EnableWindow(TRUE);

		GetDlgItem(IDC_EDIT_PHASE_NUM)->EnableWindow(TRUE);
		GetDlgItem(IDC_Clear)->EnableWindow(TRUE);
	}else{
		//ڑ
		GetDlgItem(IDC_Connect)->EnableWindow(TRUE);
		GetDlgItem(IDC_AddrConnect)->EnableWindow(TRUE);
		GetDlgItem(IDC_Disconnect)->EnableWindow(FALSE);

		GetDlgItem(IDC_NUMBER)->EnableWindow(TRUE);
		GetDlgItem(IDC_ADDRESS)->EnableWindow(TRUE);

		GetDlgItem(IDC_CWSPIN)->EnableWindow(FALSE);
		GetDlgItem(IDC_CCWSPIN)->EnableWindow(FALSE);
		GetDlgItem(IDC_RESOLVE1)->EnableWindow(FALSE);
		GetDlgItem(IDC_RESOLVE10)->EnableWindow(FALSE);
		GetDlgItem(IDC_CURRENT_ON)->EnableWindow(FALSE);
		GetDlgItem(IDC_CURRENT_OFF)->EnableWindow(FALSE);

		GetDlgItem(IDC_Start)->EnableWindow(FALSE);
		GetDlgItem(IDC_Stop)->EnableWindow(FALSE);
		GetDlgItem(IDC_Reset)->EnableWindow(FALSE);

		GetDlgItem(IDC_ENABLE_NUM)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_CUR)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_NUM)->EnableWindow(FALSE);
		GetDlgItem(IDC_FREQ)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_FREQ)->EnableWindow(FALSE);

		GetDlgItem(IDC_MOTOR_ON)->EnableWindow(FALSE);
		GetDlgItem(IDC_MOTOR_OFF)->EnableWindow(FALSE);
		GetDlgItem(IDC_ALARM_ON)->EnableWindow(FALSE);
		GetDlgItem(IDC_ALARM_OFF)->EnableWindow(FALSE);

		GetDlgItem(IDC_EDIT_PHASE_NUM)->EnableWindow(FALSE);
		GetDlgItem(IDC_Clear)->EnableWindow(FALSE);
	}
	if(m_flgUpdate == TRUE) UpdateData(FALSE);
}

//PWM̐ݒ
void CMotorSampleDlg::UpdatePwmParam(void)
{
	TW_STATUS ret;
	CString str;
	double Freq = 0.0;
	double Duty = 0.5;
	double Phase = 0.0;

	Freq = m_SldFreq.GetPos();

	if(ret = TWXA_TimerSetPwm(m_hDev, 0, &Freq, &Duty, &Phase)){
		OnBnClickedDisconnect();
		str.Format(_T("G[܂:TW_STATUS=%08X"), ret);
		AfxMessageBox(str);
		return;
	}

	//g\ɔf
	m_Freq = (long)Freq;
	//XC_[ɔf
	m_SldFreq.SetPos((long)(Freq + 0.5));
	UpdateData(FALSE);
}

//GfBbg\̓emF
void CMotorSampleDlg::CheckEdit(void)
{
	long nSpin, nFreq;

	nSpin = m_Num;
	nFreq = m_Freq;
	if(UpdateData(TRUE) == FALSE){
		m_Num = nSpin;
		m_Freq = nFreq;
		UpdateData(FALSE);
	}
}

BOOL CMotorSampleDlg::PreTranslateMessage(MSG* pMsg)
{
	if(pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_RETURN){  //G^[L[ꂽꍇ
		switch(GetFocus()->GetDlgCtrlID()){
			case IDC_EDIT_NUM:  //pXwGfBbg{bNX̕ҏW
				TRACE(_T("Focus To IDC_EDIT_NUM\n"));
				OnEnKillfocusEditNum();
				m_flgUpdate = FALSE;
				break;

			case IDC_EDIT_FREQ:  //o͎g\GfBbg{bNX̕ҏW
				TRACE(_T("Focus To IDC_EDIT_FREQ\n"));
				OnEnKillfocusEditFreq();
				m_flgUpdate = FALSE;
				break;
		}
		return FALSE;
	}

	return CDialog::PreTranslateMessage(pMsg);
}
