'**********************************************************************************
'  TWXA.vb
'
'  XV:2011/10/19
'
'  Copyright (C) Technowave Ltd. 2011
'**********************************************************************************

Option Strict On
Option Explicit On 

Imports System.Runtime.InteropServices

Module TWXA
  '֐̖߂l
  Public Enum TW_STATUS As Integer
    TW_OK
    TW_INVALID_HANDLE
    TW_DEVICE_NOT_FOUND
    TW_DEVICE_NOT_OPENED
    TW_IO_ERROR
    TW_INSUFFICIENT_RESOURCES
    TW_INVALID_PARAMETER
    TW_INVALID_BAUD_RATE
    TW_DEVICE_NOT_OPENED_FOR_ERASE
    TW_DEVICE_NOT_OPENED_FOR_WRITE
    TW_FAILED_TO_WRITE_DEVICE
    TW_EEPROM_READ_FAILED
    TW_EEPROM_WRITE_FAILED
    TW_EEPROM_ERASE_FAILED
    TW_EEPROM_NOT_PRESENT
    TW_EEPROM_NOT_PROGRAMMED
    TW_INVALID_ARGS
    TW_NOT_SUPPORTED
    TW_OTHER_ERROR

    TW_TIMEOUT = &HFFFF0001 'M܂͎M^CAEg
    TW_FILE_ERROR           't@CɊւG[
    TW_MEMORY_ERROR         '̊mۃG[
    TW_DATA_NOT_FOUND       'Lȃf[^
    TW_SOCKET_ERROR         'Socket API ̃G[
    TW_ACCESS_DENIED        'F؃G[
    TW_NOT_SUPPORTED_MODE   'Ăяoꂽ֐݂͌̃[hł̓T|[gȂ
    TW_FLASH_MODE_DEVICE    'ڑfoCXʏ탂[hŖߐłȂ

    'ATF֘AG[
    TW_ATF_ERR_FILE_VERSION = &HFFFF0101 'Ήo[WVt@CtH[}bg
    TW_ATF_ERR_ILLEGAL_FILE              't@C̓es
    TW_ATF_ERR_SERVICE_VERSION           'gpT[rXfoCXT|[gĂȂ
    TW_ATF_ERR_PASSWORD_REQUIRED         'ATF𕜍邽߂̃pX[hKv

    'tbV֘AG[
    TW_FLASH_ERR_DOWNLOAD = &HFFFF0201 '_E[hG[(tbVpvO̓]Ɏs)
    TW_FLASH_ERR_INIT                  'G[
    TW_FLASH_ERR_ERASE                 'G[
    TW_FLASH_ERR_WRITE                 '݃G[
    TW_FLASH_ERR_COMMAND               'R}hG[
    TW_FLASH_ERR_CHKSUM                '`FbNTG[
    TW_FLASH_ERR_SIZE = &HFFFF0210     'TCY̎w肪s
    TW_FLASH_ERR_ADDRESS               'AhX̎w肪s
    TW_FLASH_ERR_NOT_ERASED            'ޑOɏKv
  End Enum

  Public Const TW_ATF_STATUS As Integer = &HFFFFFE00 'ATFŋʂɎgpXe[^X̐擪ԍ
  Public Const TW_USER_ERR As Integer = &HFFFFFF00   '[U[`̃Xe[^X̐擪ԍ(&HFFFFFF00-&HFFFFFFFF)
  Public Const TW_INVALID_SOCKET As Integer = -1     'ȃ\Pbg\萔

  'TWXA_Open()̃IvV
  Public Enum TWXA_OPEN_OPT As Integer
    ''' <summary>ڑ\ȑSẴfoCXΏۂɐڑ</summary>
    ANY_DEVICE = &HFFFF0000
    ''' <summary>LANfoCXɐڑ</summary>
    IF_LAN = &H40000000
    ''' <summary>USBfoCXɐڑ</summary>
    IF_USB = &H20000000
    ''' <summary>C^tF[X͖ȂŐڑ</summary>
    IF_ANY = &HFF000000
    ''' <summary>N2219^CṽfoCXɐڑ</summary>
    TYPE_N2219 = &H10000
    ''' <summary>I2219^CṽfoCXɐڑ</summary>
    TYPE_I2219 = &H20000
    ''' <summary>i^Cv͖ȂŐڑ</summary>
    TYPE_ANY = &HFF0000
    ''' <summary>LANfoCX񋓂e[uXV</summary>
    LIST_UPDATE = &H1
  End Enum

  'TWXA_InitializȅIvV
  Public Enum TWXA_INIT_OPT As Integer
    ''' <summary>S@\</summary>
    ALL = &HFFFFFFFF
    ''' <summary>o͒[q̏o͒l</summary>
    PORT_DATA = &H2
    ''' <summary>16rbg^C}</summary>
    TIMER = &H10
    ''' <summary>VA|[g</summary>
    SCI = &H40
    ''' <summary>pXJE^</summary>
    PC = &H80
    ''' <summary>DA</summary>
    DA = &H200
  End Enum

  '݉\ȃ|[g
  Public Enum TWXA_WPORT As Integer
    ''' <summary>[U[Xe[^Xi[ȂǂɎgpł郌WX^</summary>
    USER_STATUS = &HFFE7F6
    DA0 = &HFFFF9C     'DA0
    DA1 = &HFFFF9D     'DA1
    POd = &HFFFFD3     'Od
    POe = &HFFFFFFFF   'Oe
    POf = &HFFFFFFFD   'Of
  End Enum

  'Ǐo\ȃ|[g
  Public Enum TWXA_RPORT As Integer
    ''' <summary>[U[Xe[^Xi[ȂǂɎgpł郌WX^</summary>
    USER_STATUS = &HFFE7F6
    DA0 = &HFFFF9C     'DA0
    DA1 = &HFFFF9D     'DA1
    PIa = &HFFFFD0     'Ia
    PIb = &HFFFFD1     'Ib
    PIc = &HFFFFFFFE   'Ic
    POd = &HFFFFD3     'Od
    POe = &HFFFFFFFF   'Oe
    POf = &HFFFFFFFD   'Of
  End Enum

  'pXJE^\萔
  Public Enum TWXA_PC_BITS As Integer
    PC0 = &H10
    PC1 = &H20
    PC2 = &H2
    PC3 = &H4
    ''' <summary>PC0PC1</summary>
    PC0_PC1 = &H30
    ''' <summary>PC2PC3</summary>
    PC2_PC3 = &H6
    ''' <summary>SĂPC`l</summary>
    PC_ALL = &H36
  End Enum

  Public Enum TWXA_PC_MODE As Integer
    ''' <summary>dx"Lo""Hi"ƂȂƂJEg</summary>
    COUNT_RISE = 0
    ''' <summary>2JEg</summary>
    COUNT_2PHASE = 1
    ''' <summary>3JEgBPC2,PC32JEgAPC0ŃNA</summary>
    COUNT_3PHASE = 2
    ''' <summary>dx"Hi""Lo"ƂȂƂJEg</summary>
    COUNT_FALL = 3
    ''' <summary>͂"OFF""ON"ɂȂƂJEg</summary>
    COUNT_OFF_TO_ON = 3
    ''' <summary>͂"ON""OFF"ɂȂƂJEg</summary>
    COUNT_ON_TO_OFF = 0
  End Enum

  '^C}̃`lw肷rbg
  Public Enum TWXA_TIMER_BITS As Integer
    TIMER0 = &H1
    TIMER1 = &H2
    TIMER2 = &H4
    TIMER_ALL = &H7
  End Enum

  '16rbg^C}̓샂[h
  Public Enum TWXA_TIMER_MODE As Integer
    ''' <summary>PWM[h</summary>
    DISABLE = &H0
    ''' <summary>PWM[h</summary>
    PWM = &H1
    ''' <summary>dx"Lo""Hi"ƂȂƂJEg</summary>
    COUNT_RISE = &H2
    ''' <summary>dx"Hi""Lo"ƂȂƂJEg</summary>
    COUNT_FALL = &H3
    ''' <summary>GbWPJEg</summary>
    COUNT_BOTH = &H4
    ''' <summary>2JEg(2ch.̂ݐݒ\)</summary>
    COUNT_2PHASE = &H5
    ''' <summary>͂"OFF""ON"ɂȂƂJEg</summary>
    COUNT_OFF_TO_ON = &H3
    ''' <summary>͂"ON""OFF"ɂȂƂJEg</summary>
    COUNT_ON_TO_OFF = &H2
  End Enum

  'VA[h
  Public Enum TWXA_SCI_MODE As Integer
    DATA8 = &H0     '8rbgf[^
    DATA7 = &H40    '7rbgf[^
    NO_PARITY = &H0  'peBȂ
    EVEN = &H20     'peB
    ODD = &H30      'peB
    STOP1 = &H0     '1Xgbvrbg
    STOP2 = &H8     '2Xgbvrbg
  End Enum

  'VA{[[g
  Public Enum TWXA_SCI_BAUD As Integer
    BAUD300 = &H2A2
    BAUD600 = &H250
    BAUD1200 = &H1A2
    BAUD2400 = &H150
    BAUD4800 = &HA2
    BAUD9600 = &H50
    BAUD14400 = &H35
    BAUD19200 = &H28
    BAUD38400 = &H13
  End Enum

  Public Const TWXA_EB1_TOP As Integer = &H1000 'EB1̐擪AhX
  Public Const TWXA_EB2_TOP As Integer = &H2000 'EB2̐擪AhX
  Public Const TWXA_EB3_TOP As Integer = &H3000 'EB3̐擪AhX

  'TWXA_HW_EVENT\̂Eventɐݒ肷l
  Public Const TWXA_EVENT_PC0 As Integer = &H1         'PC0Ď
  Public Const TWXA_EVENT_PC1 As Integer = &H2         'PC1Ď
  Public Const TWXA_EVENT_PC2 As Integer = &H4         'PC2Ď
  Public Const TWXA_EVENT_PC3 As Integer = &H8         'PC3Ď
  Public Const TWXA_EVENT_AD0 As Integer = &H10        'AD0Ď
  Public Const TWXA_EVENT_AD1 As Integer = &H20        'AD1Ď
  Public Const TWXA_EVENT_AD2 As Integer = &H40        'AD2Ď
  Public Const TWXA_EVENT_AD3 As Integer = &H80        'AD3Ď
  Public Const TWXA_EVENT_USER As Integer = &H80000000 '[U[`([U[t@[ʐMsꍇ)
  Public Const TWXA_EVENT_PC_ALL As Integer = &HF      'PC`lĎ
  Public Const TWXA_EVENT_AD_ALL As Integer = &HF0     'AD`lĎ

  Public Const TWXA_CMP_GE As Integer = &H7FFFFFFF 'JE^wlȏɂȂꍇʒm
  Public Const TWXA_CMP_LE As Integer = &H80000000 'JE^wlȉɂȂꍇʒm
  Public Const TWXA_CMP_NO As Integer = &H0 'JE^ɕωꍇʒm

  '[U[ɊJꂽRAM̈(&HFFBF20-&HFFE71F)
  Public Const TWXA_USER_AREA As Integer = &HFFBF20

  '\
  <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Ansi, Pack:=4)> _
  Public Structure TWXA_ATF_INFO
    Public FormatVer As Integer      't@CtH[}bg̃o[W
    Public FirmwareVer As Integer    'Kvȃt@[EFÃo[W
    <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=32)> _
    Public Description As String     'ATF̖́AȂ
    <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=32)> _
    Public Manufacture As String     '
    Public ProgramVer As Integer     '[߂ĂvÕo[W
    Public AddressTop As Integer     'gpRAM̈̐擪AhX
    Public AddressBottom As Integer  'gpRAM̈̍ŏIAhX+1
    Public CommandAddress As Integer 'R}hnh̃AhX
    Public EncryptMode As Short      'Í(0:ȂA1:\A2:[U[pX[hɂÍ)
    Public wRsv As Short
    Public MainAddress As Integer    'C֐̃AhX
  End Structure

  <StructLayout(LayoutKind.Sequential)> _
  Public Structure TWXA_HW_EVENT
    Public hRecvWindow As System.IntPtr 'bZ[W̑M̃EBhȄꍇnhݒ(svȏꍇ0)
    Public idRecvThread As Integer      'bZ[W̑M悪Xbh̏ꍇIDݒ(svȏꍇ0)
    Public lpRsv As System.IntPtr       '\
    Public Message As Integer           'bZ[WԍWM_APPȏ
    Public EventBits As Integer         'ĎCxgrbgŎw
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> _
    Public PCCnt() As Integer     'pXJE^̔rl
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> _
    Public PCCmp() As Integer     'pXJE^̔r@(0:ωɒʒmA1:rlȏŒʒmA-1:rlȉŒʒm)
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> _
    Public ADVal() As Integer     'AD̔rlB16rbg0A16rbgMSB10rbggp( As Integer = &H0040-0xffc0͈̔)B
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> _
    Public ADCmp() As Short       'AD̔r@(0ȏ:ݒlȏŒʒmAȊO:ݒlȉŒʒmBl̑傫̓qXeVX)

    Public Sub Initialize()
      ReDim PCCnt(3)
      ReDim PCCmp(3)
      ReDim ADVal(3)
      ReDim ADCmp(3)
    End Sub
  End Structure

  '------------------------------------------------------------------------------
  ' ڑ^ؒf
  '------------------------------------------------------------------------------
  ''' <summary>
  ''' uԍw肵ăfoCXɐڑ܂
  ''' </summary>
  ''' <param name="phDev">nh̊i[</param>
  ''' <param name="Number">uԍB0̏ꍇ͍ŏɌfoCXɐڑ܂B</param>
  ''' <param name="Opt">ڑ IvV</param>
  Public Declare Function TWXA_Open Lib "TWXA.dll" (ByRef phDev As System.IntPtr, Optional ByVal Number As Integer = 0, Optional ByVal Opt As TWXA_OPEN_OPT = TWXA_OPEN_OPT.ANY_DEVICE Or TWXA_OPEN_OPT.LIST_UPDATE) As Integer
  ''' <summary>
  ''' AhXw肵ăfoCXɐڑ܂
  ''' </summary>
  ''' <param name="phDev">nh̊i[</param>
  ''' <param name="Address">ڑfoCX̃AhX(hCA܂́AIP)</param>
  ''' <param name="Opt">ڑIvVBʏ TWXA_IF_LAN w肵܂</param>
  Public Declare Function TWXA_OpenByAddress Lib "TWXA.dll" Alias "TWXA_OpenByAddressA" (ByRef phDev As System.IntPtr, Optional ByVal Address As String = vbNullString, Optional ByVal Opt As TWXA_OPEN_OPT = TWXA_OPEN_OPT.ANY_DEVICE) As Integer
  ''' <summary>
  ''' foCXƂ̒ʐMI܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  Public Declare Function TWXA_Close Lib "TWXA.dll" (ByVal hDev As System.IntPtr) As Integer
  ''' <summary>
  ''' vZXڑĂSẴfoCXƂ̒ʐMI܂
  ''' </summary>
  Public Declare Function TWXA_CloseAll Lib "TWXA.dll" () As Integer

  '------------------------------------------------------------------------------
  ' ڑ^ؒf(LANfoCXp)
  '------------------------------------------------------------------------------
  ''' <summary>
  ''' NCAg[hLANfoCXƐڑ邽߂̃lbg[N|[gJ܂
  ''' </summary>
  ''' <param name="pListenSocket">ڑ҂\Pbg̊i[</param>
  ''' <param name="pLocalIP">ڑ҂s[J(p\R)IPAhX</param>
  ''' <param name="PortNumber">ڑ҂s|[gԍ</param>
  Public Declare Function TWXA_Listen Lib "TWXA.dll" Alias "TWXA_ListenA" (ByRef pListenSocket As System.IntPtr, Optional ByVal pLocalIP As String = vbNullString, Optional ByVal PortNumber As Integer = 50176) As Integer
  ''' <summary>
  ''' NCAg[hLANfoCXƐڑ邽߂̃lbg[N|[g܂
  ''' </summary>
  ''' <param name="ListenSocket"></param>
  ''' <returns></returns>
  ''' <remarks></remarks>
  Public Declare Function TWXA_CloseListenSocket Lib "TWXA.dll" (ByVal ListenSocket As System.IntPtr) As Integer
  ''' <summary>
  ''' ڑ҂LANfoCX󂯓܂
  ''' </summary>
  ''' <param name="ListenSocket">ڑ҂\Pbg</param>
  ''' <param name="phDev">foCXւ̃nh̊i[</param>
  Public Declare Function TWXA_Accept Lib "TWXA.dll" (ByVal ListenSocket As System.IntPtr, ByRef phDev As System.IntPtr) As Integer

  '------------------------------------------------------------------------------
  ' |[g^
  '------------------------------------------------------------------------------
  ''' <summary>
  ''' o̓|[gfoCXRAM̈1oCg̃f[^݂܂B
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="Port">݉\ȃ|[gA܂́AAhX</param>
  ''' <param name="Data">ރf[^</param>
  ''' <param name="Mask">}XNlB}XNl1̃rbĝݑ삳܂</param>
  Public Declare Function TWXA_PortWrite Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal Port As TWXA_WPORT, ByVal Data As Byte, Optional ByVal Mask As Byte = &HFF) As Integer
  ''' <summary>
  ''' ̓|[gfoCXRAM̈悩1oCg̃f[^݂܂B
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="Port">Ǐo\ȃ|[gA܂́AAhX</param>
  ''' <param name="pData">[o]ǂݏof[^̊i[</param>
  Public Declare Function TWXA_PortRead Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal Port As TWXA_RPORT, ByRef pData As Byte) As Integer

  '------------------------------------------------------------------------------
  ' AiÓ^AiOlϊ
  '------------------------------------------------------------------------------
  ''' <summary>
  ''' w`lADϊʂǂݏo܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="Ch">`l(0-3)</param>
  ''' <param name="pData">[o]ǂݏof[^̊i[</param>
  Public Declare Function TWXA_ADRead Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal Ch As Integer, ByRef pData As Integer) As Integer
  ''' <summary>
  ''' dlDAɐݒ肷邽߂̐ɕϊ܂
  ''' </summary>
  ''' <param name="pData">[]]̓dl [o]ݒ\ȓdl</param>
  ''' <param name="Opt">\B0Ƃ܂</param>
  Public Declare Function TWXA_An8FromVolt Lib "TWXA.dll" (ByRef pData As Double, Optional ByVal Opt As Integer = 0) As Byte
  ''' <summary>
  ''' AiO͂̎擾ldɕϊ܂B
  ''' </summary>
  ''' <param name="Data">AiO͂̎擾l</param>
  ''' <param name="Opt">\B0Ƃ܂</param>
  Public Declare Function TWXA_An16ToVolt Lib "TWXA.dll" (ByVal Data As Integer, Optional ByVal Opt As Integer = 0) As Double

  '------------------------------------------------------------------------------
  ' pXJE^(\tgEFAJE^)
  '------------------------------------------------------------------------------
  ''' <summary>
  ''' pXJE^̃[hݒ肵܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="ChBits">ݒ肷`l</param>
  ''' <param name="Mode">JEg[h</param>
  Public Declare Function TWXA_PCSetMode Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal ChBits As TWXA_PC_BITS, ByVal Mode As TWXA_PC_MODE) As Integer
  ''' <summary>
  ''' pXJE^̃JEgJn܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="ChBits">Jn`l</param>
  Public Declare Function TWXA_PCStart Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal ChBits As TWXA_PC_BITS) As Integer
  ''' <summary>
  ''' pXJE^̃JEg~܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="ChBits">I`l</param>
  Public Declare Function TWXA_PCStop Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal ChBits As TWXA_PC_BITS) As Integer
  ''' <summary>
  ''' pXJE^̃JEglǂݏo܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="ChBits">ǂݏo`l</param>
  ''' <param name="pCnt">[o]JEgl̊i[</param>
  Public Declare Function TWXA_PCReadCnt Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal ChBits As TWXA_PC_BITS, ByRef pCnt As Integer) As Integer
  ''' <summary>
  ''' pXJE^̃JEglݒ肵܂BJE^NAꍇȂǂɎgp܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="ChBits">ރ`l</param>
  ''' <param name="Cnt">JEgl</param>
  Public Declare Function TWXA_PCSetCnt Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal ChBits As TWXA_PC_BITS, ByVal Cnt As Integer) As Integer

  '------------------------------------------------------------------------------
  ' ^C}JE^(n[hEFAJE^)
  '------------------------------------------------------------------------------
  ''' <summary>
  ''' ^C}(n[hEFAJE^)̓샂[hݒ肵܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="Ch">ݒ肷`l(0-2)</param>
  ''' <param name="Mode">샂[h</param>
  Public Declare Function TWXA_TimerSetMode Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal Ch As Integer, ByVal Mode As TWXA_TIMER_MODE) As Integer
  ''' <summary>
  ''' PWM̃pXݒs܂B쎞͏ʑ̒l͖܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="Ch">`l</param>
  ''' <param name="pFrequency">[]]̎g [o]ۂɐݒłg</param>
  ''' <param name="pDuty">[]]̃f[eB(0-1.0) [o]ۂɐݒłg</param>
  ''' <param name="pPhase">[]]̏ʑ(0-1.0) [o]ۂɐݒłʑ</param>
  Public Declare Function TWXA_TimerSetPwm Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal Ch As Integer, ByRef pFrequency As Double, Optional ByRef pDuty As Double = Nothing, Optional ByRef pPhase As Double = Nothing) As Integer
  ''' <summary>
  ''' ONbNgpPWM̃pXݒs܂B쎞͏ʑ̒l͖܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="Ch">`l</param>
  ''' <param name="dClkFreq" >͂NbNg(HzP)BTCLK1ɓ͂܂</param>
  ''' <param name="pFrequency">[]]̎g [o]ۂɐݒłg(HzP)</param>
  ''' <param name="pDuty">[]]̃f[eB(0-1.0) [o]ۂɐݒłg</param>
  ''' <param name="pPhase">[]]̏ʑ(0-1.0) [o]ۂɐݒłʑ</param>
  Public Declare Function TWXA_TimerSetPwmExt Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal Ch As Integer, ByVal dClkFreq As Double, ByRef pFrequency As Double, Optional ByRef pDuty As Double = Nothing, Optional ByRef pPhase As Double = Nothing) As Integer
  ''' <summary>
  ''' ^C}(n[hEFAJE^)̓Jn܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="ChBits">Jn`l</param>
  Public Declare Function TWXA_TimerStart Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal ChBits As TWXA_TIMER_BITS) As Integer
  ''' <summary>
  ''' ^C}(n[hEFAJE^)̓~܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="ChBits">~`l</param>
  Public Declare Function TWXA_TimerStop Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal ChBits As TWXA_TIMER_BITS) As Integer
  ''' <summary>
  ''' ^C}(n[hEFAJE^)̃JEglǂݏo܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="Ch">`l(0-2)</param>
  ''' <param name="pCnt">[o]JEgl̊i[</param>
  Public Declare Function TWXA_TimerReadCnt Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal Ch As Integer, ByRef pCnt As Short) As Integer
  ''' <summary>
  ''' ^C}(n[hEFAJE^)̃JEglǂݏo܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="Ch">`l(0-2)</param>
  ''' <param name="pCnt">[o]JEgl̊i[</param>
  Public Declare Function TWXA_TimerReadCnt Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal Ch As Integer, ByRef pCnt As System.UInt16) As Integer
  ''' <summary>
  ''' ^C}(n[hEFAJE^)̃JEglݒ肵܂BJE^NAꍇȂǂɎgp܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="Ch">`l(0-2)</param>
  ''' <param name="Cnt">JEgl</param>
  Public Declare Function TWXA_TimerSetCnt Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal Ch As Integer, ByVal Cnt As Short) As Integer
  ''' <summary>
  ''' ^C}(n[hEFAJE^)̃JEglݒ肵܂BJE^NAꍇȂǂɎgp܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="Ch">`l(0-2)</param>
  ''' <param name="Cnt">JEgl</param>
  Public Declare Function TWXA_TimerSetCnt Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal Ch As Integer, ByVal Cnt As System.UInt16) As Integer
  ''' <summary>
  ''' PWM̏o̓pXݒ肵܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="Ch">`l</param>
  ''' <param name="nPulse">o̓pXB-1̏ꍇ͒~w܂ŏo͂𑱂܂</param>
  Public Declare Function TWXA_TimerSetNumOfPulse Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal Ch As Integer, Optional ByVal nPulse As Integer = &HFFFFFFFF) As Integer
  ''' <summary>
  ''' PWM̏o̓pX̎cǂݏo܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="Ch">`l</param>
  ''' <param name="pnPulse">[o]cpX̊i[</param>
  Public Declare Function TWXA_TimerReadNumOfPulse Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal Ch As Integer, ByRef pnPulse As Integer) As Integer
  ''' <summary>
  ''' 쒆̃^C}`lrbgŕԂ܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="pStatus">[o]쒆̃`lBrbg0-21̏ꍇAꂼ0-2`l쒆܂</param>
  Public Declare Function TWXA_TimerReadStatus Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByRef pStatus As Integer) As Integer
  ''' <summary>
  ''' PWMo͂ƂȂĂ^C}`l̏o͂Cӂ̒lɐݒ肵܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="ChBits">o͂ONɂ`lrbgŎw肵܂BwÕ`lOFFƂȂ܂</param>
  Public Declare Function TWXA_TimerSetLevel Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal ChBits As TWXA_TIMER_BITS) As Integer

  '------------------------------------------------------------------------------
  ' VA|[g
  '------------------------------------------------------------------------------
  ''' <summary>
  ''' VA|[g̐ݒs܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="Ch">`l(0-1)</param>
  ''' <param name="Mode">샂[h</param>
  ''' <param name="Baud">{[[g</param>
  Public Declare Function TWXA_SCISetMode Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal Ch As Integer, Optional ByVal Mode As TWXA_SCI_MODE = &H0I, Optional ByVal Baud As TWXA_SCI_BAUD = TWXA_SCI_BAUD.BAUD9600) As Integer
  ''' <summary>
  ''' VA|[g̃Xe[^XƎMobt@̃oCgǂݏo܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="Ch">`l</param>
  ''' <param name="pStatus">[o]Xe[^X̊i[</param>
  ''' <param name="pnReceive">[o]Mobt@̃oCg̊i[</param>
  Public Declare Function TWXA_SCIReadStatus Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal Ch As Integer, ByRef pStatus As Byte, ByRef pnReceive As Integer) As Integer
  ''' <summary>
  ''' foCX̃VA|[gMf[^ǂݏo܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="Ch">`l</param>
  ''' <param name="pData">ǂݏof[^̊i[</param>
  ''' <param name="nData">ǂݏof[^̃oCg(0-255)</param>
  ''' <param name="pnRead">[o]ۂɓǂݏof[^̊i[</param>
  Public Declare Function TWXA_SCIRead Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal Ch As Integer, <MarshalAs(UnmanagedType.AsAny), InAttribute(), OutAttribute()> ByVal pData As Object, ByVal nData As Integer, Optional ByRef pnRead As Integer = Nothing) As Integer
  ''' <summary>
  ''' foCX̃VA|[gf[^𑗐M܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="Ch">`l</param>
  ''' <param name="pData">Mf[^</param>
  ''' <param name="nData">Mf[^̃oCg(0-255)</param>
  Public Declare Function TWXA_SCIWrite Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal Ch As Integer, <MarshalAs(UnmanagedType.AsAny)> ByVal pData As Object, ByVal nData As Integer) As Integer
  ''' <summary>
  ''' VA|[g̎Mf[^؂邽߂̃f~^R[hݒ肵܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="Ch">`l</param>
  ''' <param name="pData">ݒ肷f~^R[h</param>
  ''' <param name="nDelimiter">f~^̃oCg(0-2)</param>
  Public Declare Function TWXA_SCISetDelimiter Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal Ch As Integer, ByVal pData() As Byte, ByVal nDelimiter As Integer) As Integer
  ''' <summary>
  ''' VA|[g̎Mf[^؂邽߂̃f~^R[hݒ肵܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="Ch">`l</param>
  ''' <param name="pData">ݒ肷f~^R[h</param>
  ''' <param name="nDelimiter">f~^̃oCg(0-2)</param>
  Public Declare Function TWXA_SCISetDelimiter Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal Ch As Integer, ByVal pData As String, ByVal nDelimiter As Integer) As Integer

  '------------------------------------------------------------------------------
  ' [U[t@[Ȃ
  '------------------------------------------------------------------------------
  ''' <summary>
  ''' [U[t@[ɃR}h𑗐M܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="Command">R}hR[h</param>
  ''' <param name="Param1">R}ḧ1</param>
  ''' <param name="Param2">R}ḧ2</param>
  ''' <param name="pData">ǉ̃f[^</param>
  ''' <param name="nData">ǉ̃f[^</param>
  Public Declare Function TWXA_ATFUserCommand Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal Command As Short, Optional ByVal Param1 As Integer = 0, Optional ByVal Param2 As Integer = 0, <MarshalAs(UnmanagedType.AsAny)> Optional ByVal pData As Object = Nothing, Optional ByVal nData As Integer = 0) As Integer
  ''' <summary>
  ''' A^b`gt@[(.atft@C)foCXɃ_E[h܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="FileName">.atft@C̃pX</param>
  ''' <param name="Reserve">\BNothingƂĂ</param>
  Public Declare Function TWXA_ATFDownload Lib "TWXA.dll" Alias "TWXA_ATFDownloadA" (ByVal hDev As System.IntPtr, ByVal FileName As String, Optional ByVal Reserve As String = Nothing) As Integer
  ''' <summary>
  ''' A^b`gt@[(.atft@C)̏擾܂
  ''' </summary>
  ''' <param name="FileName">.atft@C̃pX</param>
  ''' <param name="pInfo">[o]i[TWXA_ATF_INFO\</param>
  Public Declare Function TWXA_ATFGetInfo Lib "TWXA.dll" Alias "TWXA_ATFGetInfoA" (ByVal FileName As String, ByRef pInfo As TWXA_ATF_INFO) As Integer
  ''' <summary>
  ''' [U[t@[Ƀf[^𑗐M܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="pData">Mf[^</param>
  ''' <param name="nData">Mf[^̃oCg</param>
  ''' <param name="pWritten">[o]ۂɑMoCg̊i[</param>
  Public Declare Function TWXA_Write Lib "TWXA.dll" (ByVal hDev As System.IntPtr, <MarshalAs(UnmanagedType.AsAny)> ByVal pData As Object, ByVal nData As Integer, ByRef pWritten As Integer) As Integer
  ''' <summary>
  ''' [U[t@[f[^ǂݏo܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="pData">ǂݏof[^̊i[</param>
  ''' <param name="nData">ǂݏof[^</param>
  ''' <param name="pRead">[o]ۂɓǂݏooCg̊i[</param>
  Public Declare Function TWXA_Read Lib "TWXA.dll" (ByVal hDev As System.IntPtr, <MarshalAs(UnmanagedType.AsAny), InAttribute(), OutAttribute()> ByVal pData As Object, ByVal nData As Integer, ByRef pRead As Integer) As Integer
  ''' <summary>
  ''' foCX̎Mf[^~obt@̃f[^oCg𒲂ׂ܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="pnQueue">[o]MoCg̊i[</param>
  Public Declare Function TWXA_GetQueueStatus Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByRef pnQueue As Integer) As Integer
  ''' <summary>
  ''' foCX̃ɏ݂s܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="Port">AhX</param>
  ''' <param name="pData">ރf[^</param>
  ''' <param name="nData">ރf[^</param>
  Public Declare Function TWXA_PortBWrite Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal Port As Integer, <MarshalAs(UnmanagedType.AsAny)> ByVal pData As Object, ByVal nData As Integer) As Integer
  ''' <summary>
  ''' foCX̃ǂݏos܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="Port">AhX</param>
  ''' <param name="pData">ǂݏof[^̊i[</param>
  ''' <param name="nData">ǂݏof[^</param>
  Public Declare Function TWXA_PortBRead Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal Port As Integer, <MarshalAs(UnmanagedType.AsAny), InAttribute(), OutAttribute()> ByVal pData As Object, ByVal nData As Integer) As Integer
  ''' <summary>
  ''' foCX̎Mf[^~obt@NA܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  Public Declare Function TWXA_Purge Lib "TWXA.dll" (ByVal hDev As System.IntPtr) As Integer

  '------------------------------------------------------------------------------
  ' tbV
  '------------------------------------------------------------------------------
  ''' <summary>
  ''' tbV̏^݂s߂̃A^b`gt@[foCXɃ_E[h܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  Public Declare Function TWXA_FlashAttachWriter Lib "TWXA.dll" (ByVal hDev As System.IntPtr) As Integer
  ''' <summary>
  ''' tbV̎wubN܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="Blk">ubNԍ(1-3)</param>
  Public Declare Function TWXA_FlashEraseBlk Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal Blk As Integer) As Integer
  ''' <summary>
  ''' tbVւ݂̏s܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="Address">݃AhX(&amp;H1000-&amp;H3F80,128oCgE)</param>
  ''' <param name="pData">ރf[^</param>
  ''' <param name="nData">(0-4096,128oCgP)</param>
  Public Declare Function TWXA_FlashWrite Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByVal Address As Integer, <MarshalAs(UnmanagedType.AsAny)> ByVal pData As Object, ByVal nData As Integer) As Integer

  '------------------------------------------------------------------------------
  ' Cxg
  '------------------------------------------------------------------------------
  ''' <summary>
  ''' pXJE^AAiO͂̃CxgbZ[WƂĒʒm邽߂̐ݒs܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="pHwEvent">TWXA_HW_EVENT\</param>
  Public Declare Function TWXA_SetHwEvent Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByRef pHwEvent As TWXA_HW_EVENT) As Integer

  '------------------------------------------------------------------------------
  ' ̑̊֐
  '------------------------------------------------------------------------------
  ''' <summary>
  ''' foCX܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="Opt">IvV</param>
  Public Declare Function TWXA_Initialize Lib "TWXA.dll" (ByVal hDev As System.IntPtr, Optional ByVal Opt As TWXA_INIT_OPT = TWXA_INIT_OPT.ALL) As Integer
  ''' <summary>
  ''' foCX̃t@[EFAo[W擾܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="pVersion">[o]o[W̊i[</param>
  Public Declare Function TWXA_ReadVersion Lib "TWXA.dll" (ByVal hDev As System.IntPtr, ByRef pVersion As Integer) As Integer
  ''' <summary>
  ''' foCXւ̑MюM̃^CAEgw肵܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  ''' <param name="dwReadTimeout">M̃^CAEg(msecP)</param>
  ''' <param name="dwWriteTimeout">M̃^CAEg(msecP)</param>
  Public Declare Function TWXA_SetTimeouts Lib "TWXA.dll" (ByVal hDev As System.IntPtr, Optional ByVal dwReadTimeout As Integer = 5000, Optional ByVal dwWriteTimeout As Integer = 5000) As Integer
  ''' <summary>
  ''' foCX̑uԍ擾܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  Public Declare Function TWXA_GetNumber Lib "TWXA.dll" (ByVal hDev As System.IntPtr) As Integer
  ''' <summary>
  ''' LANfoCXɐڑ邽߂̃pX[hύX܂
  ''' </summary>
  ''' <param name="pPass">pX[h</param>
  Public Declare Function TWXA_SetPassword Lib "TWXA.dll" Alias "TWXA_SetPasswordA" (Optional ByVal pPass As String = vbNullString) As Integer
  ''' <summary>
  ''' LANfoCXɐڑۂ̃|[gԍύX܂
  ''' </summary>
  ''' <param name="PortNumber">|[gԍ</param>
  Public Declare Function TWXA_SetNetworkPort Lib "TWXA.dll" (Optional ByVal PortNumber As Integer = 49152) As Integer
  ''' <summary>
  ''' LANfoCXƐڑĂ\Pbg擾܂
  ''' </summary>
  ''' <param name="hDev">foCX̃nh</param>
  Public Declare Function TWXA_GetSocket Lib "TWXA.dll" (ByVal hDev As System.IntPtr) As System.IntPtr


End Module