// MotorSampleDlg.h : wb_[ t@C
//

#pragma once

#include "TWXA.h"
#include "afxwin.h"
#include "afxcmn.h"

#pragma comment(lib, "TWXA.lib")

// CMotorSampleDlg _CAO
class CMotorSampleDlg : public CDialog
{
// RXgNV
public:
	CMotorSampleDlg(CWnd* pParent = NULL);	// WRXgN^

// _CAO f[^
	enum { IDD = IDD_MOTORSAMPLE_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV T|[g


// 
protected:
	HICON m_hIcon;

	// ꂽAbZ[W蓖Ċ֐
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

private:
	TW_HANDLE m_hDev;
	long m_lnPhase;
	WORD m_wnTemp;
	BOOL m_flgStart;
	BOOL m_flgUpdate;
	void UpdateControlEnable(BOOL startFlg = FALSE);
	void UpdatePwmParam(void);
	void CheckEdit(void);
public:
	long m_DevNum;
	CString m_Address;
	BOOL m_SlctSpin;
	BOOL m_SlctResolve;
	BOOL m_SlctCurrent;
	long m_CurNum;
	long m_Num;
	CSliderCtrl m_SldFreq;
	long m_Freq;
	BOOL m_InfoSpin;
	long m_PhaseNum;
	BOOL m_InfoAlarm;
	afx_msg void OnBnClickedConnect();
	afx_msg void OnBnClickedAddrconnect();
	afx_msg void OnBnClickedDisconnect();
	afx_msg void OnBnClickedStart();
	afx_msg void OnBnClickedStop();
	afx_msg void OnBnClickedEnableNum();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnBnClickedClear();
	afx_msg void OnBnClickedReset();
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnBnClickedResolve1();
	afx_msg void OnBnClickedResolve10();
	afx_msg void OnBnClickedCurrentOn();
	afx_msg void OnBnClickedCurrentOff();
	afx_msg void OnEnSetfocusEditNum();
	afx_msg void OnEnKillfocusEditNum();
	afx_msg void OnEnSetfocusEditFreq();
	afx_msg void OnEnKillfocusEditFreq();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
};
